<h1 align="center">
  <br>
  <a href="https://github.com/IcelyFramework/icely-activity-storming"><img src="docs/lighthouse.png" alt="Icely Activity Storming" width="200"></a>
  <br>
  Icely Activity Storming
  <br>
</h1>

<h4 align="center">A Modeling Tool and metamodel for explore, visualize, design, formalize business domain.</h4>

<p align="center">
  <img alt="GitHub release (latest by date)" src="https://img.shields.io/github/v/release/IcelyFramework/icely-activity-storming">
  <img alt="GitHub last commit" src="https://img.shields.io/github/last-commit/IcelyFramework/icely-activity-storming">
  <img alt="GitHub" src="https://img.shields.io/github/license/IcelyFramework/icely-activity-storming">
  <img alt="GitHub Repo stars" src="https://img.shields.io/github/stars/IcelyFramework/icely-activity-storming?style=social">
</p>

<p align="center">
  <a href="#about">About</a> •
  <a href="#user-content--key-features">Key Features</a> •
  <a href="#user-content--how-to-use">How To Use</a> •
  <a href="#user-content--roadmap">Roadmap</a> •
  <a href="#user-content--contributing">Contributing</a> •
  <a href="#license">License</a>
</p>

![screenshot](docs/screenshot.png)

## About
Activity Diagram + Event Storming = **Icely Activity Storming**  !!

Icely Activity Storming is a modeling tool for and metamodel for explore, visualize, design, formalize business domain and behavioural view.

## ✨ Key Features
* Design clean and maintainable Event-Driven software and CQRS Architecture
* Dig into the business flow
* Explore and Visualize Domain Model
* Generate EMF-Based and GMF-Based Model
* Usable as Standalone Package

## 🚀 How To Use

### Using Update Site
You can use the update site through the `Help->Install new software` menu in Eclipse to install Icely Activity Storming from:  
[https://icelyframework.github.io/icely-activity-storming/updates/](https://icelyframework.github.io/icely-activity-storming/updates/)

### Using Standalone as Package
To use Icely Activity Storming as standlone package, JARs are available from Github Packages.

Example using Maven:
```xml
<dependencies>
  ...
    <dependency>
        <groupId>com.github.icelyframework.activitystorming</groupId>
        <artifactId>com.github.icelyframework.activitystorming</artifactId>
        <version>1.0.4</version>
    </dependency>
  ...
</dependencies>
```

Example using Gradle Groovy:
```groovy
dependencies {
    implementation 'com.github.icelyframework.activitystorming:com.github.icelyframework.activitystorming:1.0.1'
}
```
## Development (In Progress)

## ☑ Roadmap
If you want to see a new feature feel free to create a new Issue. Here are some features which are either underway or planned:

- [x] Deploy To Github Packages

If you'd like to give any of these a shot feel free to contribute.

## Support

<a href="https://www.buymeacoffee.com/amirdeljouyi" target="_blank"><img src="https://www.buymeacoffee.com/assets/img/custom_images/purple_img.png" alt="Buy Me A Coffee" style="height: 41px !important;width: 174px !important;box-shadow: 0px 3px 2px 0px rgba(190, 190, 190, 0.5) !important;-webkit-box-shadow: 0px 3px 2px 0px rgba(190, 190, 190, 0.5) !important;" ></a>

## License

Copyright © 2021 [Amir Deljouyi](https://github.com/amirdeljouyi).  
Icely Annotator is made available under the [MIT](https://github.com/IcelyFramework/icely-annotator/blob/main/LICENSE) licensed.

## 🤝 Contributing
Contributions, issues and feature requests are welcome.  
Feel free to check [issues page](https://github.com/IcelyFramework/icely-annotator/issues) if you want to contribute.

---

> [amirdeljouyi](http://ce.sharif.edu/~deljouyi) &nbsp;&middot;&nbsp;
> GitHub [@amirdeljouyi](https://github.com/amirdeljouyi) &nbsp;&middot;&nbsp;
> Twitter [@amirdeljouyi](https://twitter.com/amirdeljouyi)
